theory beiso
  imports "../mml/subset_1"
begin

(* General *)
text_raw \<open>\DefineSnippet{beIsoT}{\<close>
definition "beIsoT(h2s,s2h,T) \<longleftrightarrow> ((\<forall>\<^sub>Ly. s2h(h2s(y)) =\<^sub>\<H> y) \<and> 
  (\<forall> x:T. h2s(s2h(x)) =\<^sub>\<S> x)\<and> (\<forall>\<^sub>Ly. h2s(y) be T))"
text_raw \<open>}%EndSnippet\<close>

text_raw \<open>\DefineSnippet{beIsoS}{\<close>
definition "beIsoS(h2s,s2h,d) \<longleftrightarrow> ((\<forall>\<^sub>Ly. s2h(h2s(y)) =\<^sub>\<H> y) \<and>
  (\<forall>x:Element-of d. h2s(s2h(x)) =\<^sub>\<S> x)\<and> (\<forall>\<^sub>Ly. h2s(y) in d))"
text_raw \<open>}%EndSnippet\<close>


text_raw \<open>\DefineSnippet{beIsoS_d}{\<close>
theorem beIsoS_d:
  "beIsoS(h2s,s2h,d) \<Longrightarrow> d is non empty" 
text_raw \<open>}%EndSnippet\<close>
proof-
  assume "beIsoS(h2s,s2h,d)"
  then have "(\<forall>\<^sub>Ly. h2s(y) in d)" using beIsoS_def[of h2s s2h d] by auto
  hence "h2s(THE x . True ) in d" by auto
  thus "d is non empty" using xboole_0_def_1 all_set by auto
qed

text_raw \<open>\DefineSnippet{beIsoT_d}{\<close>
theorem beIsoT_d:
  "beIsoT(h2s,s2h,T) \<Longrightarrow> inhabited(T)" 
text_raw \<open>}%EndSnippet\<close>
proof-
  assume "beIsoT(h2s,s2h,T)"
  then have "(\<forall>\<^sub>Ly. h2s(y) be T)" using beIsoT_def[of h2s s2h T] by auto
  hence "h2s(THE x . True ) be T" by auto
  thus "inhabited(T)" using all_set inhabited_def by auto
qed

text_raw \<open>\DefineSnippet{beIso_d}{\<close>
theorem beIsoProp:
  "beIsoS(h2s,s2h,d) \<Longrightarrow> d be non empty" 
  "beIsoT(h2s,s2h,T) \<Longrightarrow> inhabited(T)" 
text_raw \<open>}%EndSnippet\<close>
  using beIsoT_d[of "h2s" "s2h"]  beIsoS_d[of "h2s" "s2h"] by auto


text_raw \<open>\DefineSnippet{beIsoT_m}{\<close>
theorem beIsoT_m: 
  "beIsoT(h2s,s2h,T) \<Longrightarrow> h2s(x) be T" 
text_raw \<open>}%EndSnippet\<close>
proof-
  assume "beIsoT(h2s,s2h,T)"
  thus "h2s(x) be T" using beIsoT_def[of h2s s2h T] by auto
qed

text_raw \<open>\DefineSnippet{beIsoS_m}{\<close>
theorem beIsoS_m: 
  "beIsoS(h2s,s2h,d) \<Longrightarrow> h2s(x) is Element-of d" 
text_raw \<open>}%EndSnippet\<close>
proof-
  assume "beIsoS(h2s,s2h,d)"
  hence "h2s(x) in d" using beIsoS_def[of h2s s2h d] by auto
  thus "h2s(x) is Element-of d" using Element(6) all_set by auto
qed

text_raw \<open>\DefineSnippet{beIsoS_e}{\<close>
theorem beIsoS_e: "beIsoS(h2s,s2h,d) \<Longrightarrow> 
  x is Element-of d \<Longrightarrow> h2s(s2h(x)) =\<^sub>\<S> x "
text_raw \<open>}%EndSnippet\<close>
proof-
  have [ex]:" inhabited(Element-of d)" using  subset_1_def_1_ex all_set by auto
  assume "beIsoS(h2s,s2h,d)" " x is Element-of d"
  thus "h2s(s2h(x)) = x" using beIsoS_def[of h2s s2h d] all_set by auto
qed

text_raw \<open>\DefineSnippet{beIsoS_i}{\<close>
theorem beIsoS_i: 
  "beIsoS(h2s,s2h,d) \<Longrightarrow> s2h(h2s(x)) =\<^sub>\<H> x " using beIsoS_def[of h2s s2h d] by auto
text_raw \<open>}%EndSnippet\<close>


text_raw \<open>\DefineSnippet{beIsoT_e}{\<close>
theorem beIsoT_e: "beIsoT(h2s,s2h,T) \<Longrightarrow> 
  x be T \<Longrightarrow> h2s(s2h(x)) =\<^sub>\<S> x "
text_raw \<open>}%EndSnippet\<close>
proof-
  assume A:"beIsoT(h2s,s2h,T)" " x be T"
  hence [ex]:" inhabited(T)" using beIsoT_d by auto  
  show "h2s(s2h(x)) = x" using beIsoT_def[of h2s s2h T] A by auto
qed

text_raw \<open>\DefineSnippet{beIsoT_i}{\<close>
theorem beIsoT_i: 
  "beIsoT(h2s,s2h,T) \<Longrightarrow> s2h(h2s(x)) =\<^sub>\<H> x " using beIsoT_def[of h2s s2h T] by auto
text_raw \<open>}%EndSnippet\<close>

text_raw \<open>\DefineSnippet{beIsoTS}{\<close>
theorem beIsoS_Type_Set:
  assumes "\<And> x. x be T iff x in d"
  shows "beIsoT(h2s,s2h,T) \<Longrightarrow> beIsoS(h2s,s2h,d)"
        "beIsoS(h2s,s2h,d) \<Longrightarrow> beIsoT(h2s,s2h,T)"
text_raw \<open>}%EndSnippet\<close>
proof-
  assume A: "beIsoT(h2s,s2h,T)"
  show "beIsoS(h2s,s2h,d)" unfolding beIsoS_def
  proof(intro conjI)
    show "\<forall>\<^sub>Ly. s2h(h2s(y)) =\<^sub>\<H> y" using A[unfolded beIsoT_def] by auto
    have [ty]:"d be set" using all_set by auto
    have [ex]: "inhabited(T)" using beIsoT_d A by auto
    hence "(the T) be T" by auto
    hence "the T in d" using assms by auto
    hence [ty]: "not d is empty" using xboole_0_def_1 by auto
    show "\<forall>x:Element-of d. h2s(s2h(x)) = x"
    proof
      fix x assume "x be Element-of d"
      hence "x in d" using Element(7) by auto
      hence "x be T" using assms by auto
      then show "h2s(s2h(x)) = x"  using A[unfolded beIsoT_def] by auto
    qed mauto
    show "\<forall>\<^sub>Ly. h2s(y) in d"
    proof fix y
      have "h2s(y) is T" using A[unfolded beIsoT_def] by auto
      then show "h2s(y) in d" using assms by auto
    qed
  qed
next
  assume A:"beIsoS(h2s,s2h,d)"
  show "beIsoT(h2s,s2h,T)" unfolding beIsoT_def
  proof(intro conjI)
    have [ty]:"d be set" using all_set by auto
    show "\<forall>\<^sub>Ly. s2h(h2s(y)) =\<^sub>\<H> y" using A[unfolded beIsoS_def] by auto 
    have "(\<forall>\<^sub>Ly. h2s(y) in d)" using beIsoS_def[of h2s s2h d] A by auto
    hence "h2s(THE x . True ) in d" by auto
    hence "h2s(THE x . True ) be T" using assms by auto
    hence [ex]: "inhabited(T)" using inhabited_def by auto
    show "\<forall>x : T. h2s(s2h(x)) = x" 
    proof
      fix x assume "x be T" hence "x in d" using assms by auto
      hence "x be Element-of d" using Element(6) by auto
      then show "h2s(s2h(x)) = x" using A[unfolded beIsoS_def] by auto
    qed mauto
    show "\<forall>\<^sub>Ly. h2s(y) be T" using assms A[unfolded beIsoS_def] by auto
  qed
qed



text_raw \<open>\DefineSnippet{TransformHS1}{\<close>
definition TransformHS1 where
 "func TransformHS1(s2hX,h2sY,HFun,x) \<rightarrow> set equals
    h2sY(HFun(s2hX(x)))"
text_raw \<open>}%EndSnippet\<close>

schematic_goal TransformHS1:
  shows "?X" apply (rule func_equals_property[OF TransformHS1_def],simp add:all_set) done



theorem TransformHS1_typeS:
  assumes "beIsoS(h2sY,s2hY,Y)"
  shows "TransformHS1(s2hX, h2sY,IsaFun,x) is Element-of Y"
  using TransformHS1[of s2hX  h2sY IsaFun] beIsoS_m[OF assms] by auto


theorem Transform1_MIS:
  assumes "beIsoS(h2sX,s2hX,X)"
  shows "TransformHS1(s2hX, h2sY,IsaFun,h2sX(x)) = h2sY (IsaFun(x))"
proof-
  have "TransformHS1(s2hX, h2sY,IsaFun,h2sX(x)) 
          = h2sY(IsaFun(s2hX(h2sX(x))))" 
    using TransformHS1[of s2hX h2sY IsaFun] by mty auto 
  then show "TransformHS1(s2hX, h2sY,IsaFun,h2sX(x))  = h2sY(IsaFun(x))" 
       using beIsoS_i[OF assms]  by auto
qed

theorem Transform1_IMS:
  assumes "beIsoS(h2sY,s2hY,Y)" 
  shows "s2hY (TransformHS1(s2hX, h2sY,IsaFun,x)) =\<^sub>\<H> IsaFun(s2hX(x))"
proof-
  let ?T="TransformHS1(s2hX, h2sY,IsaFun,x)"
  let ?I="IsaFun(s2hX(x))"
  have "s2hY(?T) =\<^sub>\<H> s2hY(h2sY(?I))" using TransformHS1[of s2hX h2sY IsaFun] by mty auto
  then show "s2hY(?T) =\<^sub>\<H> ?I" using beIsoS_i[OF assms] by mty auto 
qed

theorem TransformHS1_typeT:
  assumes "beIsoT(h2sY,s2hY,Y)"
  shows "TransformHS1(s2hX, h2sY,IsaFun,x) is Y"
  using TransformHS1[of s2hX  h2sY IsaFun] beIsoT_m[OF assms] by auto


theorem Transform1_MIT:
  assumes "beIsoT(h2sX,s2hX,X)" 
  shows "TransformHS1(s2hX, h2sY,IsaFun,h2sX(x)) = h2sY (IsaFun(x))"
proof-
  have "TransformHS1(s2hX, h2sY,IsaFun,h2sX(x)) 
          = h2sY(IsaFun(s2hX(h2sX(x))))" 
    using TransformHS1[of s2hX h2sY IsaFun] by mty auto 
  then show "TransformHS1(s2hX, h2sY,IsaFun,h2sX(x))  = h2sY(IsaFun(x))" 
       using beIsoT_i[OF assms] by auto
qed

theorem Transform1_IMT:
  assumes "beIsoT(h2sY,s2hY,Y)" 
  shows "s2hY (TransformHS1(s2hX, h2sY,IsaFun,x)) =\<^sub>\<H> IsaFun(s2hX(x))"
proof-
  let ?T="TransformHS1(s2hX, h2sY,IsaFun,x)"
  let ?I="IsaFun(s2hX(x))"
  have "s2hY(?T) =\<^sub>\<H> s2hY(h2sY(?I))" using TransformHS1[of s2hX h2sY IsaFun] by mty auto
  then show "s2hY(?T) =\<^sub>\<H> ?I" using beIsoT_i[OF assms] by mty auto 
qed
















text_raw \<open>\DefineSnippet{TransformHS2}{\<close>
definition TransformHS2 where
 "func TransformHS2(s2hX1,s2hX2,h2sY,HFun,x1,x2) \<rightarrow> set equals
    h2sY(HFun(s2hX1(x1),s2hX2(x2)))"
text_raw \<open>}%EndSnippet\<close>

schematic_goal TransformHS2:
  shows "?X" apply (rule func_equals_property[OF TransformHS2_def],simp add:all_set) done



theorem TransformHS2_typeS:
  assumes "beIsoS(h2sY,s2hY,Y)"
  shows "TransformHS2(s2hX1,s2hX2, h2sY,IsaFun,x1,x2) is Element-of Y"
  using TransformHS2[of s2hX1 s2hX2  h2sY IsaFun] beIsoS_m[OF assms] by auto


theorem Transform2_MIS:
  assumes "beIsoS(h2sX1,s2hX1,X1)" "beIsoS(h2sX2,s2hX2,X2)"
  shows "TransformHS2(s2hX1,s2hX2, h2sY,IsaFun,h2sX1(x1),h2sX2(x2)) = h2sY (IsaFun(x1,x2))"
proof-
  have "TransformHS2(s2hX1,s2hX2, h2sY,IsaFun,h2sX1(x1),h2sX2(x2)) 
          = h2sY(IsaFun(s2hX1(h2sX1(x1)),s2hX2(h2sX2(x2))))" 
    using TransformHS2[of s2hX1 s2hX2 h2sY IsaFun] by mty auto 
  then show "TransformHS2(s2hX1,s2hX2, h2sY,IsaFun,h2sX1(x1),h2sX2(x2))  = h2sY(IsaFun(x1,x2))" 
       using beIsoS_i[OF assms(2)] beIsoS_i[OF assms(1)] by auto
qed

theorem Transform2_IMS:
  assumes "beIsoS(h2sY,s2hY,Y)" 
  shows "s2hY (TransformHS2(s2hX1,s2hX2, h2sY,IsaFun,x1,x2)) =\<^sub>\<H> IsaFun(s2hX1(x1),s2hX2(x2))"
proof-
  let ?T="TransformHS2(s2hX1,s2hX2, h2sY,IsaFun,x1,x2)"
  let ?I="IsaFun(s2hX1(x1),s2hX2(x2))"
  have "s2hY(?T) =\<^sub>\<H> s2hY(h2sY(?I))" using TransformHS2[of s2hX1 s2hX2 h2sY IsaFun] by mty auto
  then show "s2hY(?T) =\<^sub>\<H> ?I" using beIsoS_i[OF assms] by mty auto 
qed

theorem TransformHS2_typeT:
  assumes "beIsoT(h2sY,s2hY,Y)"
  shows "TransformHS2(s2hX1,s2hX2, h2sY,IsaFun,x1,x2) is Y"
  using TransformHS2[of s2hX1 s2hX2  h2sY IsaFun] beIsoT_m[OF assms] by auto


theorem Transform2_MIT:
  assumes "beIsoT(h2sX1,s2hX1,X1)" "beIsoT(h2sX2,s2hX2,X2)"
  shows "TransformHS2(s2hX1,s2hX2, h2sY,IsaFun,h2sX1(x1),h2sX2(x2)) = h2sY (IsaFun(x1,x2))"
proof-
  have "TransformHS2(s2hX1,s2hX2, h2sY,IsaFun,h2sX1(x1),h2sX2(x2)) 
          = h2sY(IsaFun(s2hX1(h2sX1(x1)),s2hX2(h2sX2(x2))))" 
    using TransformHS2[of s2hX1 s2hX2 h2sY IsaFun] by mty auto 
  then show "TransformHS2(s2hX1,s2hX2, h2sY,IsaFun,h2sX1(x1),h2sX2(x2))  = h2sY(IsaFun(x1,x2))" 
       using beIsoT_i[OF assms(2)] beIsoT_i[OF assms(1)] by auto
qed

theorem Transform2_IMT:
  assumes "beIsoT(h2sY,s2hY,Y)" 
  shows "s2hY (TransformHS2(s2hX1,s2hX2, h2sY,IsaFun,x1,x2)) =\<^sub>\<H> IsaFun(s2hX1(x1),s2hX2(x2))"
proof-
  let ?T="TransformHS2(s2hX1,s2hX2, h2sY,IsaFun,x1,x2)"
  let ?I="IsaFun(s2hX1(x1),s2hX2(x2))"
  have "s2hY(?T) =\<^sub>\<H> s2hY(h2sY(?I))" using TransformHS2[of s2hX1 s2hX2 h2sY IsaFun] by mty auto
  then show "s2hY(?T) =\<^sub>\<H> ?I" using beIsoT_i[OF assms] by mty auto 
qed


end