theory finseq_list
  imports "../mml/finseq_1" nat_nat
begin


lemma wf_ending: "wf (Collect (\<lambda>((a1,  x), (a2, y)). a1 =\<^sub>\<H> a2 \<and> x is FinSequence \<and> y is FinSequence \<and> (x ending-of y)))"
proof (rule wfI[of _ "Collect (case_prod  (\<lambda>b c. (c is FinSequence)))" 
       "Collect (case_prod (\<lambda>b c. (c is FinSequence)))"], simp, blast, case_tac x, simp del: ty_intersection)
  fix x P b c
  assume A1: " \<forall>\<^sub>La b. (\<forall>\<^sub>Lba. ba be FinSequence \<and> b be FinSequence \<and> ba ending-of b \<longrightarrow> P((a,  ba))) \<longrightarrow> P((a, b))"
  assume A2: "c be FinSequence"
  show "P(( b, c))"
  proof(rule ending_induct[of c "\<lambda>c. P(( b, c))", OF A2],intro ballI impI)
    fix n assume A3: "n is FinSequence" "\<forall>m : FinSequence. m ending-of n \<longrightarrow> P(( b, m))"
    show "P((b, n))" using A1[rule_format, of n b] A3 by auto
  qed mauto
qed


text_raw \<open>\DefineSnippet{h2sfs}{\<close>
fun h2sfs :: "('a \<Rightarrow> Set) \<Rightarrow> 'a List.list \<Rightarrow> Set" ("h2s\<^sub>L'(_,_')")where
  "h2s\<^sub>L(h2s, Nil) =\<^sub>\<S> <*>"
| "h2s\<^sub>L(h2s, Cons(h, t)) =\<^sub>\<S> ((<*h2s(h)*>) ^M (h2s\<^sub>L(h2s, t)))"
text_raw \<open>}%EndSnippet\<close>

text_raw \<open>\DefineSnippet{s2hl}{\<close>
function s2hl :: "(Set \<Rightarrow> 'a) \<Rightarrow> Set \<Rightarrow>'a List.list" ("s2h\<^sub>L'(_,_')") where
  "\<not> x be FinSequence \<Longrightarrow> s2h\<^sub>L(s2h,x) =\<^sub>\<H> undefined" 
| "s2h\<^sub>L(s2h,<*>) =\<^sub>\<H>  Nil"
| "x be FinSequence \<Longrightarrow> x \<noteq> <*> \<Longrightarrow> s2h\<^sub>L(s2h,x) =\<^sub>\<H> Cons (s2h(x.1\<^sub>\<S>),  s2h\<^sub>L(s2h,x/^M1\<^sub>\<S>  ))" 
text_raw \<open>}%EndSnippet\<close>
  using finseq_1_def_6_ty all_set apply auto apply blast done


notation h2sfs ("h2s\<^sub>L") and s2hl ("s2h\<^sub>L")

termination
  apply standard
  using wf_ending ending_prop rfinseq_1_def_1_ty by mty auto
text_raw \<open>\DefineSnippet{FLF_prop}{\<close>
theorem FLF_prop:
  assumes "p be FinSequence-of d" and "beIsoS(h2s,s2h,d)"
  shows "h2s\<^sub>L(h2s,s2h\<^sub>L(s2h,p)) = p"
text_raw \<open>}%EndSnippet\<close>

proof-
  let ?P="\<lambda>m. for p be FinSequence-of d  st len p = m holds h2s\<^sub>L(h2s,s2h\<^sub>L(s2h,p)) = p"
  have P0: "?P({})"
  proof(rule ballI,rule impI)
    fix p assume [ty]:"p be FinSequence-of d" and "len p={}"
    hence "p=<*>" using finseq_1_def_6_p by auto
    thus "h2s\<^sub>L(h2s,s2h\<^sub>L(s2h,p)) = p"  using s2hl.simps by mty auto
  qed mauto
  have [ty]:"p be FinSequence-of d" using assms by simp
     have Pm: "for m be Nat st ?P(m) holds ?P(succ m)"
   proof(intro ballI impI)
     fix m p assume [ty]:"m be Nat" "p be FinSequence-of d" and A1: "?P(m)" "len p = succ m"
     have "len p <>{}" using A1 by auto
     hence L: "p\<noteq> <*>" using finseq_1_def_6_p by auto
     hence "p|(Seg 1\<^sub>\<S>) = <* p. 1\<^sub>\<S> *>" using finseq_5_th_20 finseq_1_def_6 by auto
     hence P: "p = <* p. 1\<^sub>\<S> *> ^M (p/^M1\<^sub>\<S>)" using rfinseq_th_8[of "1\<^sub>\<S>" p] L by mty auto
     have "1\<^sub>\<S> in dom p" using finseq_1_th_C L by mty auto
     hence "p. 1\<^sub>\<S> in rng p" "rng p c= d" using  funct_1_def_3 finseq_1_def_4[of d p] by mty auto
     hence "p. 1\<^sub>\<S> is Element-of d" using Element(6) all_set tarski_def_3E by auto 
     hence I: "h2s(s2h(p. 1\<^sub>\<S>)) = p. 1\<^sub>\<S>" using beIsoS_e[OF assms(2)] by mty auto
     have "len (p/^M1\<^sub>\<S>) = m" using A1 rfinseq_th_c[of m p] by mty auto 
     hence O: "h2s\<^sub>L(h2s,s2h\<^sub>L(s2h,p/^M1\<^sub>\<S>)) = p/^M1\<^sub>\<S>" using A1 by mty auto
     have "s2h\<^sub>L(s2h,p) =\<^sub>\<H> Cons (s2h(p .1\<^sub>\<S>),  s2h\<^sub>L(s2h,(p/^M1\<^sub>\<S> ) ))" using L by auto
     thus "h2s\<^sub>L(h2s,s2h\<^sub>L(s2h,p)) = p" using I O P by auto
   qed mauto
  have "?P(len p)" using ordinal_2_sch_19[of "len p" ?P, OF _ P0 Pm] by mty auto
  thus ?thesis by mty auto    
qed

theorem LtoF:
  "h2s\<^sub>L(h2s,p) is FinSequence"
proof(induct p)
  have "h2s\<^sub>L( h2s, Nil) = <*>" by auto
  thus "h2s\<^sub>L( h2s, Nil) is FinSequence" by mty auto
 next
   fix a p
   let ?A = "h2s(a)" let ?P=  "h2s\<^sub>L(h2s, p)" 
   assume [ty]:"?P is FinSequence"
   have "h2s\<^sub>L( h2s, Cons(a,p)) = <*?A*> ^M ?P" by auto
   thus "h2s\<^sub>L( h2s, Cons(a,p)) is FinSequence" by mty auto
 qed

theorem LtoFofD:
  assumes  G:"beIsoS(h2s,s2h,d)"
  shows "h2s\<^sub>L(h2s,p) is FinSequence-of d"
proof(induct p)
  have [ty]:" <*> is empty\<bar>set" using finseq_1_def_6 by mty auto
  hence "rng <*> = {}" using xboole_0_lm_1 by mty auto
  hence R: "rng <*> c= d" using tarski_def_3 xb all_set by mty auto
  have "h2s\<^sub>L( h2s, Nil) = <*>" by auto
  thus "h2s\<^sub>L( h2s, Nil) is FinSequence-of d" using finseq_1_def_4I R by mty auto
 next
   fix a p
   let ?A = "h2s(a)" let ?P=  "h2s\<^sub>L(h2s, p)" 
   have [ty]:"d be set" using all_set by auto
   have "?A in d"  using G beIsoS_def[of h2s s2h d] by auto
   hence [ty]: "d be non empty" " ?A is Element-of d" using xboole_0_def_1 Element(6) by auto
   have [ty]: "<*?A*> is FinSequence-of d" by mty auto
   assume [ty]:"?P is FinSequence-of d"
   have "h2s\<^sub>L( h2s, Cons(a,p)) = <*?A*> ^M ?P" by auto
   thus "h2s\<^sub>L( h2s, Cons(a,p)) is FinSequence-of d" by mty auto
 qed
text_raw \<open>\DefineSnippet{LFL_prop}{\<close>
theorem LFL_prop:
  assumes "beIsoS(h2s,s2h,d)"
  shows "s2h\<^sub>L(s2h,h2s\<^sub>L(h2s,p)) =\<^sub>\<H> p"
text_raw \<open>}%EndSnippet\<close>
proof(induct p)
   have "h2s\<^sub>L( h2s, Nil) = <*>" by auto
   thus "s2h\<^sub>L(s2h, h2s\<^sub>L( h2s, Nil)) =\<^sub>\<H> Nil" using s2hl.simps by auto
 next
   fix a p
   let ?A = "h2s(a)" let ?P=  "h2s\<^sub>L(h2s, p)" 
   let ?AP ="<* ?A *> ^M ?P"
   have [ty]:"?P is FinSequence" using LtoF by auto 
   have "<* ?A *> \<noteq> <*>" using finseq_1_lm_1 by auto
   hence AP: "?AP \<noteq> <*>" using finseq_1_th_35[of ?P] by mty auto
   have M: "s2h(h2s(a)) =\<^sub>\<H> a" using beIsoS_i[OF assms] by auto 

   assume A: "s2h\<^sub>L(s2h, ?P) =\<^sub>\<H> p"
   have  "h2s\<^sub>L( h2s, Cons(a,p)) = ?AP" by auto
   hence "s2h\<^sub>L(s2h, h2s\<^sub>L( h2s, Cons(a,p))) =\<^sub>\<H>  Cons (s2h(?AP .1\<^sub>\<S>),  s2h\<^sub>L(s2h,(?AP/^M1\<^sub>\<S> ) ))" 
     using AP s2hl.simps by mty auto
   thus "s2h\<^sub>L(s2h, h2s\<^sub>L( h2s, Cons(a,p))) =\<^sub>\<H>  Cons (a,  p)" 
     using rfinseq_th_e  rfinseq_th_d M A by mty auto
 qed

theorem beIsoS_finseq:
  "beIsoS(h2s,s2h,D) \<Longrightarrow> beIsoS(h2sfs(h2s),s2hl(s2h),D*)"
proof-
  assume G: "beIsoS(h2s,s2h,D)"
  have [ty]: "D be set" using all_set by auto
  show "beIsoS(\<lambda>list. h2s\<^sub>L(h2s,list), \<lambda>fin. s2h\<^sub>L(s2h,fin),D*)"
    unfolding beIsoS_def
  proof(intro conjI)
  let ?L = "h2sfs(h2s)" 
  let ?F="s2hl(s2h)"
  show "\<forall>\<^sub>Ly. ?F(?L(y)) =\<^sub>\<H> y" using G LFL_prop by auto
  show "\<forall>x:Element-of D*. ?L(?F(x)) = x" 
  proof(standard)
    fix x assume [ty]: "x be Element-of D*"
    hence "x in D*" using Element(7) by mty auto
    hence "x is FinSequence-of D" using finseq_1_def_11 by mty auto 
    then show "?L(?F(x)) = x" using FLF_prop G  by mty auto
  qed simp_all
  show "\<forall>\<^sub>Ly. ?L(y) in D*"
  proof
    fix y have "?L(y) is FinSequence-of D" using G LtoFofD by auto
    then show "?L(y) in D*" using finseq_1_def_11 by auto
  qed
  qed
qed

text_raw \<open>\DefineSnippet{beIsoSTfinseq}{\<close>
theorem beIsoST_finseq:
  "beIsoS(h2s,s2h,D) \<Longrightarrow> 
     beIsoT(h2s\<^sub>L (h2s),s2h\<^sub>L (s2h),FinSequence-of D)"
text_raw \<open>}%EndSnippet\<close>
proof-
  have H: "(\<And>x. x be FinSequence-of D \<longleftrightarrow> x in D*)" using finseq_1_def_11 all_set by auto
  assume A: "beIsoS(h2s,s2h,D)"
  show "beIsoT(h2sfs(h2s), s2hl(s2h), FinSequence-of D)" using beIsoS_Type_Set(2)[OF H beIsoS_finseq[OF A]] by auto
qed

text_raw \<open>\DefineSnippet{s2hlcon}{\<close>
theorem conc_M:
  assumes [ty]:"p be FinSequence" "q be FinSequence" 
  shows "s2h\<^sub>L(s2h,p^Mq) =\<^sub>\<H> s2h\<^sub>L(s2h,p) @ s2h\<^sub>L(s2h,q)"
text_raw \<open>}%EndSnippet\<close>
proof-                              
  let ?P="\<lambda>m. for p be FinSequence  st len p = m holds s2h\<^sub>L(s2h,p^Mq) =\<^sub>\<H> s2h\<^sub>L(s2h,p) @ s2h\<^sub>L(s2h,q)"
  have P0: "?P({})"
  proof(rule ballI,rule impI)
    fix p assume [ty]:"p be FinSequence" and "len p={}"
    hence "p=<*>" using finseq_1_def_6_p by auto
    thus "s2h\<^sub>L(s2h,p^Mq) =\<^sub>\<H> s2h\<^sub>L(s2h,p) @ s2h\<^sub>L(s2h,q)"  using s2hl.simps finseq_1_th_34 by mty auto
  qed mauto
  have Pm: "for m be Nat st ?P(m) holds ?P(succ m)"
   proof(intro ballI impI)
     fix m p assume [ty]:"m be Nat" "p be FinSequence" and A1: "?P(m)" "len p = succ m"
     have "len p <>{}" using A1 by auto
     hence L: "p\<noteq> <*>" using finseq_1_def_6_p by auto
     hence P: "p .1\<^sub>\<S> = (p^Mq). 1\<^sub>\<S>" using finseq_1_th_C finseq_1_def_7 by mty auto
     have Q: "(p^Mq) <> <*>" using finseq_1_th_35[of q p] finseq_1_def_6_p[of p] A1 by mty auto
     have "s2h\<^sub>L(s2h,p) @ s2h\<^sub>L(s2h,q) =\<^sub>\<H> List.list.Cons (s2h(p .1\<^sub>\<S>), s2h\<^sub>L(s2h,(p/^M1\<^sub>\<S> ))@ s2h\<^sub>L(s2h,q))" using L s2hl.simps  by auto
     hence "s2h\<^sub>L(s2h,p) @ s2h\<^sub>L(s2h,q) =\<^sub>\<H> List.list.Cons (s2h(p .1\<^sub>\<S>), s2h\<^sub>L(s2h,(p/^M1\<^sub>\<S>)^Mq))" using A1 rfinseq_th_c by mty auto
     hence "s2h\<^sub>L(s2h,p) @ s2h\<^sub>L(s2h,q) =\<^sub>\<H> List.list.Cons (s2h((p^Mq) .1\<^sub>\<S>), s2h\<^sub>L(s2h,(p^Mq)/^M1\<^sub>\<S>))" using rfinseq_th_b A1 P by mty auto
     thus " s2h\<^sub>L(s2h,p^Mq) =\<^sub>\<H> s2h\<^sub>L(s2h,p) @ s2h\<^sub>L(s2h,q)" using s2hl.simps Q by mty auto 
   qed mauto
  have "?P(len p)" using ordinal_2_sch_19[of "len p" ?P, OF _ P0 Pm] by mty auto
  thus ?thesis by mty auto    
qed

text_raw \<open>\DefineSnippet{s2hlsize}{\<close>
theorem length_len:
  assumes "p be FinSequence"
  shows "length(s2h\<^sub>L(s2h,p)) =\<^sub>\<H> s2h\<^sub>\<nat>(len p)"
text_raw \<open>}%EndSnippet\<close>
proof-
  have [ty]:"p be FinSequence" using assms by auto
  let ?P="\<lambda>m. for p be FinSequence  st len p = m holds length(s2h\<^sub>L(s2h,p)) =\<^sub>\<H> s2h\<^sub>\<nat>(len p)"
  have P0: "?P({})"
  proof(rule ballI,rule impI)
    fix p assume [ty]:"p be FinSequence" and A1: "len p={}"
    hence "p=<*>" using finseq_1_def_6_p by auto
    thus "length(s2h\<^sub>L(s2h,p)) =\<^sub>\<H> s2h\<^sub>\<nat>(len p)" using  s2hn.simps A1 by auto
  qed mauto
  have Pm: "for m be Nat st ?P(m) holds ?P(succ m)"
   proof(intro ballI impI)
     fix m p assume [ty]:"m be Nat" "p be FinSequence" and A1: "?P(m)" "len p = succ m"
     have "len p <>{}" using A1 by auto
     hence L: "p\<noteq> <*>" using finseq_1_def_6_p by auto
     hence "len (p/^M1\<^sub>\<S>) = m" using A1 rfinseq_th_c by auto     
     hence "length(s2h\<^sub>L(s2h,(p/^M1\<^sub>\<S> ) )) =\<^sub>\<H> s2h\<^sub>\<nat>(m)" using A1 by mty auto    
     hence "length(s2h\<^sub>L(s2h,p)) =\<^sub>\<H> Suc (s2h\<^sub>\<nat>(m))" using L s2hl.simps by auto
     thus "length(s2h\<^sub>L(s2h,p)) =\<^sub>\<H> (s2h\<^sub>\<nat>(len p)) " using A1 EqSuc by auto
   qed mauto
  have "?P(len p)" using ordinal_2_sch_19[of "len p" ?P, OF _ P0 Pm] by mty auto
  thus ?thesis by mty auto    
qed




theorem conc_I:
  " h2s\<^sub>L(h2s,p @ q) = h2s\<^sub>L(h2s,p) ^M h2s\<^sub>L(h2s,q)"
proof(induct p)
      case Nil 
          thus ?case using finseq_1_th_34 LtoF[of h2s q] by auto
      next
         case C: (Cons a d)                      
              have W: "<*h2s(a)*> ^M h2s\<^sub>L(h2s,d) = h2s\<^sub>L(h2s,Cons(a,d))" by auto
              have [ty]:"h2s\<^sub>L(h2s,q) is FinSequence" "h2s\<^sub>L(h2s,d) is FinSequence" using LtoF by auto
              have "h2s\<^sub>L(h2s,Cons(a,d) @ q) =\<^sub>\<H> ((<*h2s(a)*>) ^M h2s\<^sub>L(h2s,d)) ^M h2s\<^sub>L(h2s,q)" 
                using C finseq_1_th_32[of "h2s\<^sub>L(h2s,q)" "h2s\<^sub>L(h2s,d)" "<*h2s(a)*>"]  by mty auto
              thus  ?case using W by presburger
qed

text_raw \<open>\DefineSnippet{h2slsize}{\<close>
theorem len_length:
  "len(h2s\<^sub>L(h2s,p)) =\<^sub>\<H> h2s\<^sub>\<nat>(length(p))"
text_raw \<open>}%EndSnippet\<close>
proof(induct p)   
      case Nil 
        show ?case using finseq_1_def_6_p[of "<*>"] by mty auto
      next
        case C: (Cons a d)
        
                have W: "<*h2s(a)*> ^M h2s\<^sub>L(h2s,d) = h2s\<^sub>L(h2s,Cons(a,d))" by auto 

              have [ty]: "h2s\<^sub>L(h2s,d) is FinSequence" using LtoF by auto
            
              have "len(h2s\<^sub>L(h2s,Cons(a,d))) =len( <*h2s(a)*> ^M h2s\<^sub>L(h2s,d))" using W by auto
              hence "len(h2s\<^sub>L(h2s,Cons(a,d))) =len( <*h2s(a)*>) +\<^sub>\<S>\<^sup>\<nat> h2s\<^sub>\<nat>(length(d))" 
                using C finseq_1_th_22[of _ "<*h2s(a)*>"] by mty auto     
             hence "len(h2s\<^sub>L(h2s,Cons(a,d))) = succ {} +\<^sub>\<S>\<^sup>\<nat> h2s\<^sub>\<nat>(length(d))" 
                using finseq_1_def_8[of "h2s(a)"] finseq_1_def_3_uniq[of "<*h2s(a) *>" "1\<^sub>\<S>"] by mty auto     
              thus ?case using Add_5[of "h2s\<^sub>\<nat>(length(d))"] I2Mprop by mty auto
            qed


text_raw \<open>\DefineSnippet{nthL}{\<close>
theorem nth_M:
  assumes [ty]:"p be FinSequence" "n be Nat"
     and "n in len p"
   shows "s2h\<^sub>L(s2h,p) ! s2h\<^sub>\<nat>(n) =\<^sub>\<H> s2h(p. (succ n))"
text_raw \<open>}%EndSnippet\<close>
proof-
  let ?P="\<lambda>m. for p be FinSequence  st len p = m holds 
            for n be Nat st n in m holds s2h\<^sub>L(s2h,p)! s2h\<^sub>\<nat>(n) =\<^sub>\<H> s2h(p. (succ n))"
  have P0: "?P({})" using xb by auto
  have Pm: "for m be Nat st ?P(m) holds ?P(succ m)"
   proof(intro ballI impI)
     fix m p n assume [ty]:"m be Nat" "n be Nat" "p be FinSequence" and A1: "?P(m)" "len p = succ m" "n in succ m"
     have "len p <>{}" using A1 by auto
     hence L: "p\<noteq> <*>" using finseq_1_def_6_p by auto
     hence A2:"len (p/^M1\<^sub>\<S>) = m"  
       using A1 rfinseq_th_c finseq_1_def_7 by auto
     have PP: "p = <* p. 1\<^sub>\<S> *> ^M (p/^M1\<^sub>\<S>)" using L rfinseq_th_8[of "1\<^sub>\<S>" p] finseq_5_th_20[of p] by mty auto
     have A3: "s2h\<^sub>L(s2h,p) =\<^sub>\<H> Cons (s2h(p .1\<^sub>\<S>),  s2h\<^sub>L(s2h,(p/^M1\<^sub>\<S> ) ))" using L by auto
     show "s2h\<^sub>L(s2h,p)! s2h\<^sub>\<nat>(n) =\<^sub>\<H> s2h(p. (succ n))"
     proof(cases "n={}")
       case True
         hence "s2h\<^sub>\<nat>(n) =\<^sub>\<H> 0" "succ n = 1\<^sub>\<S>" by auto
         thus "s2h\<^sub>L(s2h,p)! s2h\<^sub>\<nat>(n) =\<^sub>\<H> s2h(p. (succ n))" using A3 by auto
       next
         let ?p = "predecessor(n)"
       case F: False
          hence N: "n = succ ?p" using NAT_1_5 by mty auto
          hence "s2h\<^sub>\<nat>(n) =\<^sub>\<H> Suc (s2h\<^sub>\<nat>(?p))" using EqSuc[of ?p] by mty auto
          hence B1: "s2h\<^sub>L(s2h,p)! s2h\<^sub>\<nat>(n) =\<^sub>\<H> s2h\<^sub>L(s2h,(p/^M1\<^sub>\<S> ) )! s2h\<^sub>\<nat>(?p)" using A3 by auto    
          have A4: "?p in m " "n c= m" using A1(3) N ordinal1_th_18[of m "succ ?p"] ordinal1_th_17[ of m ?p]  by mty auto
          hence B2: "s2h\<^sub>L(s2h,p/^M1\<^sub>\<S>)! s2h\<^sub>\<nat>(?p) =\<^sub>\<H> s2h((p/^M1\<^sub>\<S>) .n)" using A2 A1(1) N by mty auto
          have "1\<^sub>\<S> c= n" using F one2 by mty auto
          hence "n in dom (p/^M1\<^sub>\<S>)" using A4 A2 finseq_1_th_1 finseq_1_def_3 by mty auto
          hence B3: "(p/^M1\<^sub>\<S>) .n = p. ((len <* p. 1\<^sub>\<S>*>) +\<^sub>\<S>\<^sup>\<nat> n)" using finseq_1_def_7[of "<* p. 1\<^sub>\<S>*>" "p/^M1\<^sub>\<S>"] PP by mty auto 
          have "len <* p. 1\<^sub>\<S>*> = 1\<^sub>\<S>" using finseq_1_def_8 finseq_1_def_3_uniq[of "<* p. 1\<^sub>\<S>*>" "1\<^sub>\<S>"] by mty auto
          thus "s2h\<^sub>L(s2h,p)! s2h\<^sub>\<nat>(n) =\<^sub>\<H> s2h(p .(succ n))" using B1 B2 B3 Add_5 by auto 
        qed
   qed mauto
  have "?P(len p)" using ordinal_2_sch_19[of "len p" ?P, OF _ P0 Pm] by mty auto
  thus ?thesis using assms(3) by mty auto    
qed mauto

text_raw \<open>\DefineSnippet{s2hLprop}{\<close>
theorem s2hL_Prop:
  assumes "p be FinSequence" and "q be FinSequence" and "n be Nat" and "n in len p"
  shows  "length(s2h\<^sub>L(s2h,p)) =\<^sub>\<H> s2h\<^sub>\<nat>(len p)" 
         "s2h\<^sub>L(s2h,p^Mq) =\<^sub>\<H> s2h\<^sub>L(s2h,p) @ s2h\<^sub>L(s2h,q)"
         "s2h\<^sub>L(s2h,p) ! s2h\<^sub>\<nat>(n) =\<^sub>\<H> s2h(p. (succ n))"
text_raw \<open>}%EndSnippet\<close>
  using nth_M[of p n] length_len[of p] conc_M[of p q] assms by auto

theorem s2hL1el:
  "s2h\<^sub>L(s2h,<*a*>) =\<^sub>\<H> \<lbrakk>s2h(a)\<rbrakk>"
proof-
     have L: "<*a*> \<noteq> <*>" using finseq_1_lm_1 by mty auto
   hence "s2h\<^sub>L(s2h, <*a*>) =\<^sub>\<H> Cons(s2h(<* a *> . 1\<^sub>\<S>), s2h\<^sub>L(s2h,<* a *> /^M 1\<^sub>\<S> ))" 
       using L s2hl.simps(3)[of "<*a*>" s2h] by mty auto
   hence "s2h\<^sub>L(s2h, <*a*>) =\<^sub>\<H> Cons(s2h(a), s2h\<^sub>L(s2h,(<* a *>^M<*>) /^M 1\<^sub>\<S> ))" 
       using finseq_1_def_8 finseq_1_th_34[of "<*a*>"] by mty auto
   hence "s2h\<^sub>L(s2h, <*a*>) =\<^sub>\<H> Cons(s2h(a), s2h\<^sub>L(s2h,<*>))" 
     using rfinseq_th_d[of _ a] by mty auto
   thus "s2h\<^sub>L(s2h, <*a*>) =\<^sub>\<H> \<lbrakk>s2h(a)\<rbrakk>"  by mty auto
qed

text_raw \<open>\DefineSnippet{s2hrevprop}{\<close>
theorem rev_Rev:
  assumes "p be FinSequence"
  shows "rev(s2h\<^sub>L(s2h,p)) =\<^sub>\<H> s2h\<^sub>L(s2h,Rev p)"
text_raw \<open>}%EndSnippet\<close>
proof-
  let ?P="\<lambda>m. for p be FinSequence st len p = m holds rev(s2h\<^sub>L(s2h,p)) =\<^sub>\<H> s2h\<^sub>L(s2h,Rev p)"
  have P0: "?P({})"
  proof(rule ballI,rule impI)
    fix p assume [ty]:"p be FinSequence" and A1: "len p={}"
    hence "p=<*>" using finseq_1_def_6_p by auto
    hence A2:"s2h\<^sub>L(s2h,p) =\<^sub>\<H> Nil" "Rev p = <*>" using  s2hl.simps A1 Revempty by auto
    hence "rev(s2h\<^sub>L(s2h,p)) =\<^sub>\<H> Nil" by auto
    thus "rev(s2h\<^sub>L(s2h,p)) =\<^sub>\<H> s2h\<^sub>L(s2h,Rev p)" using  s2hl.simps A1 A2 by auto
  qed mauto
  have Pm: "for m be Nat st ?P(m) holds ?P(succ m)"
   proof(intro ballI impI)
     fix m p assume [ty]:"m be Nat" "p be FinSequence" and A1: "?P(m)" "len p = succ m"
     have "len p <>{}" using A1 by auto
     hence L: "p\<noteq> <*>" using finseq_1_def_6_p by auto
     hence "len (p/^M1\<^sub>\<S>) = m" using A1 rfinseq_th_c by auto     
     hence "rev(s2h\<^sub>L(s2h,p/^M1\<^sub>\<S>)) =\<^sub>\<H> s2h\<^sub>L(s2h,Rev (p/^M1\<^sub>\<S>))" using A1 by mty auto    
     hence "rev(s2h\<^sub>L(s2h, p)) =\<^sub>\<H> s2h\<^sub>L(s2h,Rev (p/^M1\<^sub>\<S>)) @ (s2h\<^sub>L(s2h,<*p . 1\<^sub>\<S>*>))" 
       using L s2hl.simps(3)[of "p"] s2hL1el[of s2h] by auto
     hence "rev(s2h\<^sub>L(s2h, p)) =\<^sub>\<H> s2h\<^sub>L(s2h,(Rev(p/^M1\<^sub>\<S>)) ^M <*p . 1\<^sub>\<S>*>)" 
       using conc_M[of "Rev(p/^M1\<^sub>\<S>)" "<*p . 1\<^sub>\<S>*>" s2h] by mty auto
     hence "rev(s2h\<^sub>L(s2h, p)) =\<^sub>\<H> s2h\<^sub>L(s2h,(Rev(p/^M1\<^sub>\<S>)) ^M Rev <*p . 1\<^sub>\<S>*>)" 
       using Revsing by mty auto
     hence "rev(s2h\<^sub>L(s2h, p)) =\<^sub>\<H> s2h\<^sub>L(s2h,(Rev(<*p . 1\<^sub>\<S>*> ^M (p/^M1\<^sub>\<S>))))" 
       using Revcon by mty auto
     thus "rev(s2h\<^sub>L(s2h, p)) =\<^sub>\<H> s2h\<^sub>L(s2h,(Rev p ))"
       using rfinseq_th_8[of "1\<^sub>\<S>" p] finseq_5_th_20[of p] L by mty auto
   qed mauto
  have [ty]:"p be FinSequence" using assms by simp
  have "?P(len p)" using ordinal_2_sch_19[of "len p" ?P, OF _ P0 Pm] by mty auto
  thus ?thesis by mty auto    
qed



text_raw \<open>\DefineSnippet{h2srevprop}{\<close>
theorem Rev_rev:
  "Rev(h2s\<^sub>L(h2s,p)) =\<^sub>\<S> h2s\<^sub>L(h2s,rev(p))"
text_raw \<open>}%EndSnippet\<close>
proof-
     let ?P="\<lambda> x. \<forall>\<^sub>Lp ::'a list . size(p) =\<^sub>\<H> x \<longrightarrow> Rev(h2s\<^sub>L(h2s,p)) = h2s\<^sub>L(h2s,rev(p))"
  have "\<And>m::nat.?P(m)" 
 proof-
    fix m::nat
    show "?P(m)"
    proof(induct m)
      case 0 
        show ?case using Revempty by auto
      next
        case C: (Suc m)
          show ?case 
          proof(auto)
              fix p ::"'a list" 
              assume S: "length(p) =\<^sub>\<H> Suc(m)"
              hence "not p =\<^sub>\<H> Nil" by auto
              hence D: "Cons(hd(p),tl(p)) =\<^sub>\<H> p" by auto
              hence L: "length(tl(p)) =\<^sub>\<H> m" using S by auto
              have W: "<*h2s(hd(p))*> ^M h2s\<^sub>L(h2s,tl(p)) = h2s\<^sub>L(h2s,Cons(hd(p),tl(p)))" by auto 

              have [ty]: "h2s\<^sub>L(h2s,tl(p)) is FinSequence" using LtoF by auto
              have [ty]:"h2s\<^sub>\<nat>(m) is Nat"  using I2Mprop by auto

               have "h2s\<^sub>L(h2s,Cons(hd(p),Nil)) = (<*h2s(hd(p))*>) ^M (<*>)" by auto
               hence Q: "<* h2s(hd(p)) *> = h2s\<^sub>L(h2s,Cons(hd(p),Nil))" using finseq_1_th_34 by mty auto

               have "rev(tl(p)) @ Cons(hd(p),Nil) =\<^sub>\<H> rev(Cons(hd(p),Nil)@tl(p))" by auto
               hence R: "rev(tl(p)) @ Cons(hd(p),Nil) =\<^sub>\<H> rev(p)" using D by auto

             have "Rev(h2s\<^sub>L(h2s,p)) = Rev(<*h2s(hd(p))*> ^M h2s\<^sub>L(h2s,tl(p)))" using W D by presburger
             hence "Rev(h2s\<^sub>L(h2s,p)) =  (Rev h2s\<^sub>L(h2s, tl(p))) ^M (Rev <* h2s(hd(p)) *>)" using 
               Revcon by mty auto
             hence "Rev(h2s\<^sub>L(h2s,p)) =  (h2s\<^sub>L(h2s,rev(tl(p)))) ^M (<* h2s(hd(p)) *>)" using 
                Revsing C L by mty auto
              hence "Rev(h2s\<^sub>L(h2s,p)) =  (h2s\<^sub>L(h2s,rev(tl(p)))) ^M (<* h2s(hd(p)) *>)" using 
                Revsing C L by mty auto
             hence "Rev(h2s\<^sub>L(h2s,p)) =  (h2s\<^sub>L(h2s,rev(tl(p)))) ^M h2s\<^sub>L(h2s,Cons(hd(p),Nil))" using 
                Q by presburger
              hence "Rev(h2s\<^sub>L(h2s,p)) =  h2s\<^sub>L(h2s, rev(tl(p)) @ Cons(hd(p),Nil))" using 
                conc_I[of h2s] by auto
              thus "Rev h2s\<^sub>L(\<lambda>a. h2s(a), p) =\<^sub>\<S> h2s\<^sub>L(\<lambda>a. h2s(a), rev(p))" using R by auto
            qed
          qed
        qed
        thus ?thesis by auto
qed


text_raw \<open>\DefineSnippet{len_Rev_prop_metis}{\<close>
theorem 
  assumes "p be FinSequence-of d" and "beIsoS(h2s,s2h,d)"
  shows "len Rev p =\<^sub>\<S> len p"
  using length_rev Rev_rev len_length FLF_prop assms by metis
text_raw \<open>}%EndSnippet\<close>

text_raw \<open>\DefineSnippet{len_Rev_prop_simp}{\<close>
theorem 
  assumes "p be FinSequence-of d" and "beIsoS(h2s,s2h,d)"
  shows "len Rev p =\<^sub>\<S> len p"
  using Rev_rev[of h2s "s2h\<^sub>L(s2h, p)"] 
        len_length[of h2s "s2h\<^sub>L(s2h, p)"] 
        len_length[of h2s "rev(s2h\<^sub>L(s2h, p))"]
         by (simp only: length_rev FLF_prop[OF assms])
text_raw \<open>}%EndSnippet\<close>

text_raw \<open>\DefineSnippet{len_rev}{\<close>
theorem len_rev:
  assumes "p is FinSequence"
  shows "len p =\<^sub>\<S> len Rev p" using finseq_5_def_3 assms by simp
text_raw \<open>}%EndSnippet\<close>



text_raw \<open>\DefineSnippet{length_rev_metis}{\<close>
theorem 
  fixes h2s :: "'a \<Rightarrow> Set"
  fixes p :: "'a list"
  assumes "beIsoS(h2s,s2h,d)"
  shows "length(rev(p)) =\<^sub>\<H> length(p)"
proof-
  have ty:"h2s\<^sub>L(h2s,p) is FinSequence"
          "Rev(h2s\<^sub>L(h2s,p)) is FinSequence" 
    using LtoF finseq_5_def_3_ty by auto  
  have "s2h\<^sub>L(s2h,h2s\<^sub>L(h2s,p)) =\<^sub>\<H> p" using LFL_prop assms by metis
  thus "length(rev(p)) =\<^sub>\<H> length(p)" 
      using len_rev rev_Rev length_len ty by metis
qed
text_raw \<open>}%EndSnippet\<close>

text_raw \<open>\DefineSnippet{length_rev_simp}{\<close>
theorem 
  fixes h2s :: "'a \<Rightarrow> Set"
  fixes p :: "'a list"
  assumes "beIsoS(h2s,s2h,d)"
  shows "length(rev(p)) =\<^sub>\<H> length(p)"
proof-
  have ty:"h2s\<^sub>L(h2s,p) is FinSequence" 
          "Rev(h2s\<^sub>L(h2s,p)) is FinSequence" using LtoF finseq_5_def_3_ty by auto
  have "s2h\<^sub>L(s2h,h2s\<^sub>L(h2s,p)) =\<^sub>\<H> p" using LFL_prop[OF assms] by (simp only:)
  thus "length(rev(p)) =\<^sub>\<H> length(p)" using  rev_Rev[of "h2s\<^sub>L(h2s,p)" s2h]
     length_len[of "h2s\<^sub>L(h2s,p)" s2h] length_len[of "Rev(h2s\<^sub>L(h2s,p))" s2h] 
    ty by (simp only: len_rev)
qed
text_raw \<open>}%EndSnippet\<close>
end
