theory group_group
  imports nat_nat  funct_2_lam "../mml/group_1" "../mml/algstr_0"
begin

abbreviation carrierM where "carrierM \<equiv> mizar_string.carrier"
abbreviation carrierI where "carrierI \<equiv> Congruence.carrier"
text_raw \<open>\DefineSnippet{s2hg}{\<close>
definition s2hg ("s2h\<^sub>G'(_,_,_')") where
  "s2h\<^sub>G(s2hc,h2sc,g) =\<^sub>\<H> Igroup(
     Collect(\<lambda>x. h2sc(x) in the carrier of g), 
     s2h\<^bsub>BinOp\<^esub>(s2hc,h2sc,the multF of g),
     s2hc(1.\<^sub>g))"
text_raw \<open>}%EndSnippet\<close>

theorem MtoIMult:
  assumes "beIsoS(h2sc,s2hc,c)" "the carrier of G = c"
          "x \<in> carrierI(s2h\<^sub>G(s2hc, h2sc, G))"
          "y \<in> carrierI(s2h\<^sub>G(s2hc, h2sc, G))"
          and
          [ty]: "G is multMagma" 
   shows "x \<otimes>\<^bsub>s2h\<^sub>G(s2hc,h2sc,G)\<^esub> y =\<^sub>\<H>  s2hc(h2sc(x) \<otimes>\<^sub>G h2sc(y))"
         "h2sc(x \<otimes>\<^bsub>s2h\<^sub>G(s2hc,h2sc,G)\<^esub> y) = h2sc(x) \<otimes>\<^sub>G h2sc(y)"
proof-
  let ?M = "s2h\<^sub>G(s2hc,h2sc,G)"
  have C00: "?M =\<^sub>\<H> Igroup (
          Collect( \<lambda> x . h2sc(x) in the carrier of G )  , 
          s2h\<^bsub>BinOp\<^esub>(s2hc,h2sc,the multF of G),
          s2hc(1.\<^sub>G))" using s2hg_def[of s2hc h2sc G] by auto
  have C01: "carrierI(?M) =\<^sub>\<H>  Collect( \<lambda> x . h2sc(x) in the carrierM of G )" using C00[unfolded Igroup_def] by auto
  have C02: "mult(?M) =\<^sub>\<H> s2h\<^bsub>BinOp\<^esub>(s2hc,h2sc,the multF of G)" using C00[unfolded Igroup_def] by auto
  have C: "c is non empty" using beIsoS_d[OF assms(1)] by auto
  have [ty]: "h2sc(x) is Element-of-struct G" "h2sc(y) is Element-of-struct G" using C01 assms Element(6) all_set by auto
    have "s2hc(h2sc(x)) =\<^sub>\<H> x" "s2hc(h2sc(y)) =\<^sub>\<H> y" using beIsoS_i[OF assms(1)] by auto
    hence "x \<otimes>\<^bsub>?M\<^esub> y =\<^sub>\<H>  (s2h\<^bsub>BinOp\<^esub>(s2hc,h2sc,the multF of G))(s2hc(h2sc(x)),s2hc(h2sc(y)))" using C02 by auto
    hence "x \<otimes>\<^bsub>?M\<^esub> y =\<^sub>\<H>  s2hc((the multF of G).\<lparr>h2sc(x),h2sc(y)\<rparr>)" using MtoIBinOpS[OF assms(1), of "h2sc(x)" "h2sc(y)"] assms(2) 
          by mty auto
    then show S1: "x \<otimes>\<^bsub>?M\<^esub> y =\<^sub>\<H>  s2hc(h2sc(x) \<otimes>\<^sub>G h2sc(y))" using algstr_0_def_18 assms(2) 
      by mty auto    
    have "h2sc(s2hc(h2sc(x) \<otimes>\<^sub>G h2sc(y))) = h2sc(x) \<otimes>\<^sub>G h2sc(y)" using beIsoS_e[OF assms(1)] assms by mty auto
    then show "h2sc(x \<otimes>\<^bsub>s2h\<^sub>G(s2hc,h2sc,G)\<^esub> y) = h2sc(x) \<otimes>\<^sub>G h2sc(y)" using S1 by auto
  qed
text_raw \<open>\DefineSnippet{MIGroup}{\<close>
theorem MtoIGropuProp:
  assumes "beIsoS(h2sc,s2hc,c)" and "G is Group"
    and "the carrier of G =\<^sub>\<S> c"  
  shows "group (s2h\<^sub>G(s2hc,h2sc,G))"
  text_raw \<open>}%EndSnippet\<close>
proof
  have [ty]: "G is Group" using assms by auto
  let ?M = "s2h\<^sub>G(s2hc,h2sc,G)"
  let ?E = "Element-of-struct G"
  have C00: "?M =\<^sub>\<H> Igroup (
          Collect( \<lambda> x . h2sc(x) in the carrier of G )  , 
          s2h\<^bsub>BinOp\<^esub>(s2hc,h2sc,the multF of G),
          s2hc(1.\<^sub>G))" using s2hg_def[of s2hc h2sc G] by auto
  have C: "carrierI(?M) =\<^sub>\<H>  Collect( \<lambda> x . h2sc(x) in the carrierM of G )"
            "mult(?M) =\<^sub>\<H> s2h\<^bsub>BinOp\<^esub>(s2hc,h2sc,the multF of G)" 
            "one(?M) =\<^sub>\<H> s2hc(1.\<^sub>G)" using C00[unfolded Igroup_def] by auto
  show S1: "\<And>x y. x \<in> carrierI(?M) \<Longrightarrow>
           y \<in> carrierI(?M) \<Longrightarrow> x \<otimes>\<^bsub>?M\<^esub> y \<in> carrierI(?M)"
  proof-
    fix x y assume A: "x \<in> carrierI(?M)" "y \<in> carrierI(?M)"
     hence [ty]: "h2sc(x) is ?E" "h2sc(y) is ?E" using C Element(6) all_set by auto
  
      have XY: "h2sc(x) \<otimes>\<^sub>G h2sc(y) in the carrier of G" using Element(7) all_set by mty auto
      have "h2sc(x \<otimes>\<^bsub>?M\<^esub> y) =  h2sc(x) \<otimes>\<^sub>G h2sc(y)" using algstr_0_def_18 assms(3) 
      using MtoIMult[OF assms(1) _ A] by mty auto
    then show "x \<otimes>\<^bsub>?M\<^esub> y \<in> carrierI(?M)" using C XY by auto
  qed
  show S2: " \<And>x y z.
       x \<in> carrierI(?M) \<Longrightarrow>
       y \<in> carrierI(?M) \<Longrightarrow>
       z \<in> carrierI(?M) \<Longrightarrow> x \<otimes>\<^bsub>?M\<^esub> y \<otimes>\<^bsub>?M\<^esub> z =\<^sub>\<H> x \<otimes>\<^bsub>?M\<^esub> (y \<otimes>\<^bsub>?M\<^esub> z)"
  proof-
    fix x y z assume A: "x \<in> carrierI(?M)" "y \<in> carrierI(?M)" "z \<in> carrierI(?M)"
    hence A1: "x \<otimes>\<^bsub>?M\<^esub> y  \<in> carrierI(?M)"  "y \<otimes>\<^bsub>?M\<^esub> z  \<in> carrierI(?M)" using S1 by auto
    hence [ty]: "h2sc(x) is ?E" "h2sc(y) is ?E" "h2sc(z) is ?E" 
            "h2sc(x \<otimes>\<^bsub>?M\<^esub> y) is ?E" "h2sc(y \<otimes>\<^bsub>?M\<^esub> z) is ?E" using C A Element(6) all_set by auto
    have A2:"h2sc(y \<otimes>\<^bsub>?M\<^esub> z) = h2sc(y) \<otimes>\<^sub>G h2sc(z)" using  MtoIMult[OF assms(1,3)] A1 A by mty auto
   
    have "h2sc(x \<otimes>\<^bsub>?M\<^esub> y) = h2sc(x) \<otimes>\<^sub>G h2sc(y)" using  MtoIMult[OF assms(1,3)] A1 A by mty auto
    hence "x \<otimes>\<^bsub>?M\<^esub> y \<otimes>\<^bsub>?M\<^esub> z =\<^sub>\<H> s2hc(h2sc(x) \<otimes>\<^sub>G h2sc(y) \<otimes>\<^sub>G h2sc(z))" using MtoIMult[OF assms(1,3)] A1 A by mty auto
    hence "x \<otimes>\<^bsub>?M\<^esub> y \<otimes>\<^bsub>?M\<^esub> z =\<^sub>\<H> s2hc(h2sc(x) \<otimes>\<^sub>G (h2sc(y) \<otimes>\<^sub>G h2sc(z)))" using  group_1_def_3E[of G] by mty auto
    then show "x \<otimes>\<^bsub>?M\<^esub> y \<otimes>\<^bsub>?M\<^esub> z =\<^sub>\<H> x \<otimes>\<^bsub>?M\<^esub> (y \<otimes>\<^bsub>?M\<^esub> z)" using  A2 MtoIMult[OF assms(1,3)] A1 A by mty auto
  qed
  have O: "1.\<^sub>G in the carrier of G" using Element(7) by mty auto
  have II: "h2sc(s2hc(1.\<^sub>G)) = 1.\<^sub>G" using beIsoS_e[OF assms(1), of "1.\<^sub>G"] assms(3) by mty auto
  then show S3: " \<one>\<^bsub>?M\<^esub> \<in> carrierI(?M)" using C O by auto
  show "\<And>x. x \<in> carrierI(?M) \<Longrightarrow> \<one>\<^bsub>?M\<^esub> \<otimes>\<^bsub>?M\<^esub> x =\<^sub>\<H> x"
  proof-
    fix x assume A: "x \<in> carrierI(?M)"
    hence [ty]: "h2sc(x) is ?E"  using C Element(6) all_set  by auto
    have "s2hc(1.\<^sub>G) \<otimes>\<^bsub>?M\<^esub> x =\<^sub>\<H> s2hc((1.\<^sub>G) \<otimes>\<^sub>G h2sc(x)) " using MtoIMult[OF assms(1,3)] A II S3 C by mty auto
    hence "s2hc(1.\<^sub>G) \<otimes>\<^bsub>?M\<^esub> x =\<^sub>\<H> s2hc(h2sc(x))" using group_1_def_4 by mty auto
    then show "\<one>\<^bsub>?M\<^esub> \<otimes>\<^bsub>?M\<^esub> x =\<^sub>\<H> x" using beIsoS_i[OF assms(1), of x] assms(2) C by mty auto
  qed
  show "\<And>x. x \<in> carrierI(?M) \<Longrightarrow> x \<otimes>\<^bsub>?M\<^esub> \<one>\<^bsub>?M\<^esub> =\<^sub>\<H> x"
 proof-
    fix x assume A: "x \<in> carrierI(?M)"
    hence [ty]: "h2sc(x) is ?E"  using C Element(6) all_set  by auto
    have "x \<otimes>\<^bsub>?M\<^esub> s2hc(1.\<^sub>G) =\<^sub>\<H> s2hc(h2sc(x) \<otimes>\<^sub>G (1.\<^sub>G)) " using MtoIMult[OF assms(1,3)] A II S3 C by mty auto
    hence "x \<otimes>\<^bsub>?M\<^esub> s2hc(1.\<^sub>G) =\<^sub>\<H> s2hc(h2sc(x))" using group_1_def_4 by mty auto
    then show "x \<otimes>\<^bsub>?M\<^esub> \<one>\<^bsub>?M\<^esub> =\<^sub>\<H> x" using beIsoS_i[OF assms(1), of x] assms(2) C by mty auto
  qed
  show "(\<subseteq>)(carrierI(?M), Units(?M))"
  proof
    fix y assume A:"y \<in> carrierI(?M)"
    hence [ty]: "h2sc(y) is ?E"  using C Element(6) all_set  by auto
    let ?x = "(h2sc(y))\<^sup>-\<^sup>1\<^sub>G" 
    have [ty]:"?x is ?E" by mty auto
    have O: "?x in the carrier of G" using Element(7) by mty auto
    have X: "h2sc(s2hc(?x)) = ?x" using beIsoS_e[OF assms(1), of "?x"] assms(3) by mty auto
    have C1:  "s2hc(?x)  \<in> carrierI(?M)" using O X C by auto

    hence "s2hc(?x) \<otimes>\<^bsub>?M\<^esub> y =\<^sub>\<H> s2hc(?x \<otimes>\<^sub>G h2sc(y))" using MtoIMult[OF assms(1,3)] X A by mty auto
    hence C2: "s2hc(?x) \<otimes>\<^bsub>?M\<^esub> y =\<^sub>\<H> \<one>\<^bsub>?M\<^esub>" using group_1_def_5 C by mty auto
    have  "y \<otimes>\<^bsub>?M\<^esub> s2hc(?x) =\<^sub>\<H> s2hc(h2sc(y) \<otimes>\<^sub>G ?x)" using MtoIMult[OF assms(1,3)] X A C1 by mty auto
    hence "y \<otimes>\<^bsub>?M\<^esub> s2hc(?x) =\<^sub>\<H> \<one>\<^bsub>?M\<^esub>" using group_1_def_5 C by mty auto
    hence "Ex (\<lambda>x . x \<in> carrierI(?M) & x \<otimes>\<^bsub>?M\<^esub> y =\<^sub>\<H> \<one>\<^bsub>?M\<^esub> \<and> y \<otimes>\<^bsub>?M\<^esub> x =\<^sub>\<H> \<one>\<^bsub>?M\<^esub>)" using C1 C2 by auto
    then show "y \<in> Units (?M)" using A Units_def[of ?M] by auto  
   qed
qed

text_raw \<open>\DefineSnippet{h2sg}{\<close>
definition h2sg ("h2s\<^sub>G'(_,_,_,_')") where
  "h2s\<^sub>G(s2hc,h2sc,c,g) =\<^sub>\<S> [#
    carrier \<mapsto> c; 
    multF \<mapsto> h2s\<^bsub>BinOp\<^esub>(s2hc,h2sc,c,mult(g)) #]"
text_raw \<open>}%EndSnippet\<close>


theorem h2sgProp:
  assumes "beIsoS(h2sc,s2hc,c)"
  shows "h2sg (s2hc,h2sc,c,g) is strict(multMagma)"
        "the carrierM of h2sg (s2hc,h2sc,c,g) = c"
        "the multF of h2sg (s2hc,h2sc,c,g) = h2s\<^bsub>BinOp\<^esub>(s2hc,h2sc,c,mult(g))"
proof-
  let ?I ="h2s\<^sub>G(s2hc,h2sc,c,g)"
  let ?B = "h2s\<^bsub>BinOp\<^esub>(s2hc,h2sc,c,mult(g))"
  let ?M="[#carrierM \<mapsto> c;multF \<mapsto> ?B #]"
  have [ty]: "c be set" using all_set by auto
  have [ty]: "?B is BinOp-of c" using ItoMf2prop[OF assms(1,1,1)] h2sBinOp_def[of s2hc] by auto
  have A1[ty]: "?M is strict(multMagma)" by mty auto
  then show [ty]: "?I is strict(multMagma)" unfolding h2sg_def by auto
  have "the carrierM of ?M = c" 
       "the multF of ?M = ?B" using the_selector_of_1[of _ carrierM c]  
     the_selector_of_1[of _ multF ?B] aggr by auto
  then show "the carrierM of ?I = c"
        "the multF of ?I = ?B"  unfolding h2sg_def by auto
qed

theorem ItoMmult:
  assumes "beIsoS(h2sc,s2hc,c)"
          "x is Element-of c" "y is Element-of c"
   shows "x \<otimes>\<^sub>h2s\<^sub>G(s2hc,h2sc,c,g) y =\<^sub>\<S> h2sc(s2hc(x) \<otimes>\<^bsub>g\<^esub> s2hc(y))"
         "s2hc(x \<otimes>\<^sub>h2s\<^sub>G(s2hc,h2sc,c,g) y) =\<^sub>\<H> s2hc(x) \<otimes>\<^bsub>g\<^esub> s2hc(y)"
proof-
  let ?I ="h2s\<^sub>G(s2hc,h2sc,c,g)"
  have [ty]:"?I is strict(multMagma)" "c be set" using h2sgProp[OF assms(1)] all_set by auto
  have CAR: "the carrier of ?I = c" using h2sgProp[OF assms(1)] by auto
  hence XY[ty]: "x is Element-of-struct ?I" "y is Element-of-struct ?I" using assms(2,3) by auto
  have xy: "h2sc(s2hc(x)) = x" "h2sc(s2hc(y)) = y" using beIsoS_e[OF assms(1)] CAR XY by mty auto

  have ADD: "the multF of ?I = h2s\<^bsub>BinOp\<^esub>(s2hc,h2sc,c,mult(g))" using h2sgProp[OF assms(1)] by auto
  hence "x \<otimes>\<^sub>?I  y = (h2s\<^bsub>BinOp\<^esub>(s2hc,h2sc,c,mult(g))) . \<lparr>h2sc(s2hc(x)),h2sc(s2hc(y))\<rparr>" using xy algstr_0_def_18[of ?I x y] by mty auto
  then show S1: "x \<otimes>\<^sub>?I  y = h2sc(s2hc(x) \<otimes>\<^bsub>g\<^esub> s2hc(y))" 
       using ItoMBinOpS[OF assms(1), of "mult(g)" "s2hc(x)" "s2hc(y)"] by auto
  have "s2hc(h2sc(s2hc(x) \<otimes>\<^bsub>g\<^esub> s2hc(y))) =\<^sub>\<H> s2hc(x) \<otimes>\<^bsub>g\<^esub> s2hc(y)" using  beIsoS_i[OF assms(1)] by auto
  then show "s2hc(x \<otimes>\<^sub>h2s\<^sub>G(s2hc,h2sc,c,g) y) =\<^sub>\<H> s2hc(x) \<otimes>\<^bsub>g\<^esub> s2hc(y)" using S1 by auto
qed


text_raw \<open>\DefineSnippet{IMgroup}{\<close>
theorem ItoMGroupProp:
  assumes "beIsoS(h2sc,s2hc,c)" and "group(g)"
    and "carrierI(g) =\<^sub>\<H> Collect(\<lambda>x .h2sc(x) in c)" 
  shows "h2s\<^sub>G(s2hc,h2sc,c,g) is Group"
text_raw \<open>}%EndSnippet\<close>
proof-
  have [simp]:"group(g)" using assms by auto
  have [simp]:"monoid(g)" using group_def[of g] by auto
  let ?I = "h2s\<^sub>G(s2hc,h2sc,c,g)"
  have [ty]: "?I is strict(multMagma)" and
       A1: "the carrierM of ?I = c" using h2sgProp[OF assms(1)] by auto
  have A2: "c is non empty" using beIsoS_d[OF assms(1)] by auto
  have [ty]:" ?I is non empty-struct" 
  proof
    show "\<not> the carrier of ?I is empty" using A1 A2 by simp
  qed mauto
  let ?e = "h2sc(one(g))" 
  have E[ty]: "?e is Element-of-struct ?I" using A1 beIsoS_m[OF assms(1)] by auto
  hence E0:"?e in c" using A1 Element(7)[of c] A2 by mty auto
  have E1: "s2hc(?e) =\<^sub>\<H> one(g)" using beIsoS_i[OF assms(1)] by auto
  have [ty]:" ?I is Group-like"
  proof(standard,simp,rule bexI[of _ ?e],intro ballI conjI)
    fix h assume A3[ty]: "h be Element-of-struct ?I"
    hence A4: "h in c" "h2sc(s2hc(h)) = h" using A1 Element(7)[of c] A2 beIsoS_e[OF assms(1)] by mty auto
    hence A5: "s2hc(h) \<in> carrierI(g)" using assms(3) by auto
    have "h \<otimes>\<^sub>?I ?e = h2sc(s2hc(h) \<otimes>\<^bsub>g\<^esub> one(g))" using ItoMmult[OF assms(1), of h ?e g] A1 E A3 E1 by auto 
    then show "h \<otimes>\<^sub>?I ?e = h" using monoid.r_one[of g] A5 A4 by auto
    have "?e \<otimes>\<^sub>?I h = h2sc(one(g) \<otimes>\<^bsub>g\<^esub> s2hc(h))" using ItoMmult[OF assms(1), of ?e h g] A1 E A3 E1 by auto 
    then show "?e \<otimes>\<^sub>?I h = h" using monoid.r_one[of g] A5 A4 by auto
    let ?g1 = "h2sc(inv\<^bsub>g\<^esub> s2hc(h))"
    have G[ty]: "?g1 is Element-of-struct ?I" using A1 beIsoS_m[OF assms(1)] by auto
    hence G1:"s2hc(?g1) =\<^sub>\<H> inv\<^bsub>g\<^esub> s2hc(h)" using A1 Element(7)[of c] A2 beIsoS_i[OF assms(1)] by mty auto    
    show " \<exists>ga : Element-of-struct ?I. h  \<otimes>\<^sub>?I ga = ?e \<and> ga  \<otimes>\<^sub>?I h = ?e"
    proof(rule bexI[of _ ?g1],rule conjI)
      have "h \<otimes>\<^sub>?I ?g1 = h2sc(s2hc(h)  \<otimes>\<^bsub>g\<^esub>  inv\<^bsub>g\<^esub> s2hc(h))" using ItoMmult[OF assms(1), of h ?g1 g] A1 G A3 G1 by auto 
      then show "h \<otimes>\<^sub>?I ?g1 = ?e" using group.r_inv[of g] A5 by auto
      have "?g1 \<otimes>\<^sub>?I h = h2sc((inv\<^bsub>g\<^esub> s2hc(h))  \<otimes>\<^bsub>g\<^esub>  s2hc(h))" using ItoMmult[OF assms(1), of ?g1 h g] A1 G A3 G1 by auto 
      then show "?g1 \<otimes>\<^sub>?I h = ?e" using group.l_inv[of g] A5 by auto
    qed mauto
  qed mauto
  have [ty]:" ?I is  associative"
  proof(standard,simp,intro ballI)
    fix x y z assume Z1[ty]:"x is Element-of-struct ?I" "y is Element-of-struct ?I" "z is Element-of-struct ?I"
    hence A4: "x in c" "h2sc(s2hc(x)) = x" 
              "y in c" "h2sc(s2hc(y)) = y"
              "z in c" "h2sc(s2hc(z)) = z" using A1 Element(7)[of c] A2 beIsoS_e[OF assms(1)] by mty auto        
    hence B4: "s2hc(x) \<in> carrierI(g)" "s2hc(y) \<in> carrierI(g)" "s2hc(z) \<in> carrierI(g)"using assms(3) by auto   
    have A5: "x \<otimes>\<^sub>?I y is Element-of-struct ?I" "y \<otimes>\<^sub>?I z is Element-of-struct ?I" by mty auto
       
    have  "(x \<otimes>\<^sub>?I y) \<otimes>\<^sub>?I z = h2sc(s2hc(x \<otimes>\<^sub>?I y)  \<otimes>\<^bsub>g\<^esub>  s2hc(z))" using ItoMmult[OF assms(1), of "x \<otimes>\<^sub>?I y" z  g,simplified]
      A1  Z1 A5 by mty auto 
    also have "\<dots>=h2sc(s2hc(x)  \<otimes>\<^bsub>g\<^esub>  s2hc(y)  \<otimes>\<^bsub>g\<^esub>  s2hc(z))" using ItoMmult[OF assms(1), of x y  g,simplified]
      A1 Z1 by mty auto 
    also have "\<dots>=h2sc(s2hc(x)  \<otimes>\<^bsub>g\<^esub>  (s2hc(y)  \<otimes>\<^bsub>g\<^esub>  s2hc(z)))" using monoid.m_assoc[of g] B4 by auto
    also have "\<dots>=h2sc(s2hc(x)  \<otimes>\<^bsub>g\<^esub>  s2hc(y \<otimes>\<^sub>?I z))" using ItoMmult[OF assms(1), of y z g,simplified]
      A1 Z1 by mty auto 
    also have "\<dots>=x \<otimes>\<^sub>?I (y \<otimes>\<^sub>?I z)" using ItoMmult[OF assms(1), of x "y \<otimes>\<^sub>?I z"  g,simplified]
      A1  Z1 A5 by mty auto 
    finally show "x \<otimes>\<^sub>?I y \<otimes>\<^sub>?I z = x \<otimes>\<^sub>?I (y \<otimes>\<^sub>?I z)" by simp
  qed mauto
  show "?I is Group" by mty auto
qed

theorem ItoMGOne:
  assumes "beIsoS(h2sc,s2hc,c)" and "group(g)" 
    and "carrierI(g) =\<^sub>\<H> Collect( \<lambda> x . h2sc(x) in c )"
  shows "1.\<^sub>h2s\<^sub>G(s2hc,h2sc,c,g) =\<^sub>\<S> h2sc(one(g))"
proof-
  let ?I = "h2s\<^sub>G(s2hc,h2sc,c,g)"
  let ?E="Element-of-struct ?I"
   have [simp]:"monoid(g)" using group_def[of g] assms by auto

  have [ty]:"?I is Group" using ItoMGroupProp[OF assms(1,2,3)] by simp
  have A1: "the carrierM of ?I = c" using h2sgProp[OF assms(1)] by auto
  have A2: "c is non empty" using beIsoS_d[OF assms(1)] by auto
  let ?e = "h2sc(one(g))"
  have [ty]: "?I is unital" by mty auto
  have E[ty]:"?e is ?E" using beIsoS_m[OF assms(1)] A1 by mty auto
  have E1: "s2hc(?e) =\<^sub>\<H> one(g)" using beIsoS_i[OF assms(1)] by auto

    have "for h being ?E holds
         h \<otimes>\<^sub>?I ?e = h \<and> ?e \<otimes>\<^sub>?I h = h"
    proof 
      fix h assume A3[ty]: "h is ?E"
       hence A4: "h in c" "h2sc(s2hc(h)) = h" using A1 Element(7)[of c] A2 beIsoS_e[OF assms(1)] by mty auto
    hence A5: "s2hc(h) \<in> carrierI(g)" using assms(3) by auto
    have "h \<otimes>\<^sub>?I ?e = h2sc(s2hc(h) \<otimes>\<^bsub>g\<^esub> one(g))" using ItoMmult[OF assms(1), of h ?e g] A1 E E1 A3 by auto 
    hence H1: "h \<otimes>\<^sub>?I ?e = h" using monoid.r_one[of g] A5 A4 by auto
    have "?e \<otimes>\<^sub>?I h = h2sc(one(g) \<otimes>\<^bsub>g\<^esub> s2hc(h))" using ItoMmult[OF assms(1), of ?e h g] A1 E E1 A3 by auto 
    then show "h \<otimes>\<^sub>?I ?e = h & ?e \<otimes>\<^sub>?I h = h" using monoid.r_one[of g] A5 A4 H1 by auto
    qed mauto
    then show "1.\<^sub>?I = ?e" using group_1_def_4_uniq[of ?I ?e] by mty auto 
  qed


text_raw \<open>\DefineSnippet{GGprop}{\<close>
theorem s2hg_Prop:
  assumes "beIsoS(h2sc,s2hc,c)" and "g be Group"
    and "the carrier of g =\<^sub>\<S> c"
    and "x \<in> carrierI(s2h\<^sub>G(s2hc, h2sc, g))" 
        "y \<in> carrierI(s2h\<^sub>G(s2hc, h2sc, g))"
  shows "one(s2h\<^sub>G(s2hc,h2sc,g)) =\<^sub>\<H> s2hc(1.\<^sub>g)" 
        "x \<otimes>\<^bsub>s2h\<^sub>G(s2hc,h2sc,g)\<^esub> y =\<^sub>\<H> s2hc(h2sc(x) \<otimes>\<^sub>g h2sc(y))"
        "group (s2h\<^sub>G(s2hc,h2sc,g))"
text_raw \<open>}%EndSnippet\<close>
proof-
  let ?M = "s2h\<^sub>G(s2hc,h2sc,g)"
  have C00: "?M =\<^sub>\<H> Igroup (
          Collect( \<lambda> x . h2sc(x) in the carrier of g)  , 
          s2h\<^bsub>BinOp\<^esub>(s2hc,h2sc,the multF of g),
          s2hc(1.\<^sub>g))" using s2hg_def[of s2hc h2sc g] by auto
  show "one(?M) =\<^sub>\<H>  s2hc(1.\<^sub>g)" using C00[unfolded Igroup_def] by auto
  show "x \<otimes>\<^bsub>s2h\<^sub>G(s2hc,h2sc,g)\<^esub> y =\<^sub>\<H> s2hc(h2sc(x) \<otimes>\<^sub>g h2sc(y))" using MtoIMult[OF assms(1,3,4,5)] assms(2) by auto
  show "group (s2h\<^sub>G(s2hc,h2sc,g))"
        using MtoIGropuProp[OF assms(1,2)] assms(3) by auto
    qed

text_raw \<open>\DefineSnippet{MIMgroup}{\<close>
theorem MIMgr_prop:
  assumes "beIsoS(h2sc,s2hc,c)" and "G is strict(multMagma)"
    and "the carrier of G =\<^sub>\<S> c"
  shows "h2s\<^sub>G(s2hc,h2sc,c,s2h\<^sub>G(s2hc,h2sc,G)) =\<^sub>\<S> G" 
text_raw \<open>}%EndSnippet\<close>
proof(rule Equal_strict[of _ _ multMagma])
  have [ty]:"G is strict(multMagma)" using assms by auto
  show "G be Struct" "G is strict(multMagma)" by mty auto
  let ?I="s2h\<^sub>G(s2hc,h2sc,G)"
  let ?M ="h2s\<^sub>G(s2hc,h2sc,c,?I)"
  have [ty]: "G is strict(multMagma)" "?M is strict(multMagma)" and
       A1: "the carrierM of ?M = c"
       "the multF of ?M = h2s\<^bsub>BinOp\<^esub>(s2hc,h2sc,c,mult(?I))" using h2sgProp[OF assms(1)] by auto
  then show "?M is Struct" "?M is strict(multMagma)" by auto

  fix selector
  assume A2: "selector in domain_of multMagma"
  show "the selector of ?M= the selector of G"
  proof(cases "selector = carrier")
    case True
      thus ?thesis using assms(3) A1 by auto
    next
      case False
        hence S: "selector = multF" using A2 multMagma_dom string by auto
        have "mult(?I) =\<^sub>\<H> s2h\<^bsub>BinOp\<^esub>(s2hc,h2sc,the multF of G)" using s2hg_def[of s2hc h2sc G] unfolding Igroup_def by auto
        hence "the multF of ?M = the multF of G" using MIMBinOp[OF assms(1), of "the multF of G"] assms(3) A1 by mty auto
       thus ?thesis using S by auto
     qed
qed

text_raw \<open>\DefineSnippet{IMIgroup}{\<close>
theorem IMIgr_prop:
  assumes "beIsoS(h2sc,s2hc,c)" and "group(G)" 
    and "carrierI(G) =\<^sub>\<H> Collect(\<lambda>x. h2sc(x) in c)"
  shows "s2h\<^sub>G(s2hc,h2sc,h2s\<^sub>G(s2hc,h2sc,c,G)) =\<^sub>\<H> G " 
text_raw \<open>}%EndSnippet\<close>
  unfolding s2hg_def 
proof(rule group_eq,intro conjI)
  let ?I="h2s\<^sub>G(s2hc, h2sc, c, G)"
  have [ty]: "?I is strict(multMagma)" and
        A1: "the carrierM of  ?I = c"
        "the multF of ?I = h2s\<^bsub>BinOp\<^esub>(s2hc,h2sc,c,mult(G))" using h2sgProp[OF assms(1)] by auto
  show "carrierI(G) =\<^sub>\<H> Collect(\<lambda> x. h2sc(x) in the' carrierM(?I))" using assms(3) A1 by auto
  show "mult(G) =\<^sub>\<H> s2h\<^bsub>BinOp\<^esub>(s2hc, h2sc, the multF of ?I)" using A1 IMIBinOpS[OF assms(1)] by auto
  have "h2sc(one(G)) = 1.\<^sub>?I" using ItoMGOne[OF assms(1,2,3)] by auto
  then show H3:"one(G) =\<^sub>\<H> s2hc(1.\<^sub>?I)" using beIsoS_i[OF assms(1),of "one(G)"] by auto
qed

end
